Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.text
Class NumberFormat

    java.lang.Object
      |
      +--java.text.Format
            |
            +--java.text.NumberFormat

All Implemented Interfaces:
  Cloneable, Serializable

Direct Known Subclasses:
  ChoiceFormat, DecimalFormat

public abstract class NumberFormat
extends Format

`NumberFormat` is the abstract base class for all number formats. This class provides the interface for formatting and parsing numbers. `NumberFormat` also provides methods for determining which locales have number formats, and what their names are.

`NumberFormat` helps you to format and parse numbers for any locale. Your code can be completely independent of the locale conventions for decimal points, thousands-separators, or even the particular decimal digits used, or whether the number format is even decimal.

To format a number for the current Locale, use one of the factory class methods:

>       myString = NumberFormat.getInstance().format(myNumber);

If you are formatting multiple numbers, it is more efficient to get the format and use it multiple times so that the system doesn't have to fetch the information about the local language and country conventions multiple times.

>      NumberFormat nf = NumberFormat.getInstance();
>      for (int i = 0; i < a.length; ++i) {
>          output.println(nf.format(myNumber[i]) + "; ");
>      }

To format a number for a different Locale, specify it in the call to `getInstance`.

>      NumberFormat nf = NumberFormat.getInstance(Locale.FRENCH);

You can also use a `NumberFormat` to parse numbers:

>      myNumber = nf.parse(myString);

Use `getInstance` or `getNumberInstance` to get the normal number format. Use `getCurrencyInstance` to get the currency number format. And use `getPercentInstance` to get a format for displaying percentages. With this format, a fraction like 0.53 is displayed as 53%.

You can also control the display of numbers with such methods as `setMinimumFractionDigits`. If you want even more control over the format or parsing, or want to give your users more control, you can try casting the `NumberFormat` you get from the factory methods to a `DecimalNumberFormat`. This will work for the vast majority of locales; just remember to put it in a `try` block in case you encounter an unusual one.

NumberFormat and DecimalFormat are designed such that some controls work for formatting and others work for parsing. The following is the detailed description for each these control methods,

setParseIntegerOnly : only affects parsing, e.g. if true, "3456.78" -> 3456 (and leaves the parse position just after index 6) if false, "3456.78" -> 3456.78 (and leaves the parse position just after index 8) This is independent of formatting. If you want to not show a decimal point where there might be no digits after the decimal point, use setDecimalSeparatorAlwaysShown.

setDecimalSeparatorAlwaysShown : only affects formatting, and only where there might be no digits after the decimal point, such as with a pattern like "#,##0.##", e.g., if true, 3456.00 -> "3,456." if false, 3456.00 -> "3456" This is independent of parsing. If you want parsing to stop at the decimal point, use setParseIntegerOnly.

You can also use forms of the `parse` and `format` methods with `ParsePosition` and `FieldPosition` to allow you to:

- progressively parse through pieces of a string
- align the decimal point and other areas

For example, you can align numbers in two ways:

1. If you are using a monospaced font with spacing for alignment, you can pass the `FieldPosition` in your format call, with `field` = `INTEGER_FIELD`. On output, `getEndIndex` will be set to the offset between the last character of the integer and the decimal. Add (desiredSpaceCount - getEndIndex) spaces at the front of the string.
2. If you are using proportional fonts, instead of padding with spaces, measure the width of the string in pixels from the start to `getEndIndex`. Then move the pen by (desiredPixelWidth - widthToAlignmentPoint) before drawing the text. It also works where there is no decimal, but possibly additional characters at the end, e.g., with parentheses in negative numbers: "(12)" for -12.

See Also:
  `DecimalFormat`, `ChoiceFormat`, Serialized Form

Field Summary
`static int` | `FRACTION_FIELD` Field constant used to construct a FieldPosition object.
`static int` | `INTEGER_FIELD` Field constant used to construct a FieldPosition object.

Constructor Summary
`NumberFormat()`

Method Summary
`Object` | `clone()` Overrides Cloneable
`boolean` | `equals(Object obj)` Overrides equals
`String` | `format(double number)` Specialization of format.
`abstract StringBuffer` | `format(double number, StringBuffer toAppendTo, FieldPosition pos)` Specialization of format.
`String` | `format(long number)` Specialization of format.
`abstract StringBuffer` | `format(long number, StringBuffer toAppendTo, FieldPosition pos)` Specialization of format.
`StringBuffer` | `format(Object number, StringBuffer toAppendTo, FieldPosition pos)` Formats an object to produce a string.
`static Locale[]` | `getAvailableLocales()` Get the set of Locales for which NumberFormats are installed
`static NumberFormat` | `getCurrencyInstance()` Returns a currency format for the current default locale.
`static NumberFormat` | `getCurrencyInstance(Locale inLocale)` Returns a currency format for the specified locale.
`static NumberFormat` | `getInstance()` Returns the default number format for the current default locale.
`static NumberFormat` | `getInstance(Locale inLocale)` Returns the default number format for the specified locale.
`int` | `getMaximumFractionDigits()` Returns the maximum number of digits allowed in the fraction portion of a number.
`int` | `getMaximumIntegerDigits()` Returns the maximum number of digits allowed in the integer portion of a number.
`int` | `getMinimumFractionDigits()` Returns the minimum number of digits allowed in the fraction portion of a number.
`int` | `getMinimumIntegerDigits()` Returns the minimum number of digits allowed in the integer portion of a number.
`static NumberFormat` | `getNumberInstance()` Returns a general-purpose number format for the current default locale.
`static NumberFormat` | `getNumberInstance(Locale inLocale)` Returns a general-purpose number format for the specified locale.
`static NumberFormat` | `getPercentInstance()` Returns a percentage format for the current default locale.
`static NumberFormat` | `getPercentInstance(Locale inLocale)` Returns a percentage format for the specified locale.
`int` | `hashCode()` Overrides hashCode
`boolean` | `isGroupingUsed()` Returns true if grouping is used in this format.
`boolean` | `isParseIntegerOnly()` Returns true if this format will parse numbers as integers only.
`Number` | `parse(String text)` Convenience method.
`abstract Number` | `parse(String text, ParsePosition parsePosition)` Returns a Long if possible (e.g., within the range [Long.MIN_VALUE, Long.MAX_VALUE] and with no decimals), otherwise a Double.
`Object` | `parseObject(String source, ParsePosition parsePosition)` Parses a string to produce an object.
`void` | `setGroupingUsed(boolean newValue)` Set whether or not grouping will be used in this format.
`void` | `setMaximumFractionDigits(int newValue)` Sets the maximum number of digits allowed in the fraction portion of a number.
`void` | `setMaximumIntegerDigits(int newValue)` Sets the maximum number of digits allowed in the integer portion of a number.
`void` | `setMinimumFractionDigits(int newValue)` Sets the minimum number of digits allowed in the fraction portion of a number.
`void` | `setMinimumIntegerDigits(int newValue)` Sets the minimum number of digits allowed in the integer portion of a number.
`void` | `setParseIntegerOnly(boolean value)` Sets whether or not numbers should be parsed as integers only.

Methods inherited from class java.text.Format
`format, parseObject`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### INTEGER_FIELD

    public static final int INTEGER_FIELD

  Field constant used to construct a FieldPosition object. Signifies that the position of the integer part of a formatted number should be returned.
  See Also:
    `FieldPosition`

### FRACTION_FIELD

    public static final int FRACTION_FIELD

  Field constant used to construct a FieldPosition object. Signifies that the position of the fraction part of a formatted number should be returned.
  See Also:
    `FieldPosition`

Constructor Detail

### NumberFormat

    public NumberFormat()

Method Detail

### format

    public final StringBuffer format(Object number,
                                     StringBuffer toAppendTo,
                                     FieldPosition pos)

  Formats an object to produce a string. This general routines allows polymorphic parsing and formatting for objectst.
  Overrides:
    `format` in class `Format`
  Parameters:
    `obj` - The object to format
    `toAppendTo` - where the text is to be appended
    `pos` - On input: an alignment field, if desired. On output: the offsets of the alignment field.
  Returns:
    the value passed in as toAppendTo (this allows chaining, as with StringBuffer.append())
  Throws:
    `IllegalArgumentException` - when the Format cannot format the given object.
  See Also:
    `FieldPosition`

### parseObject

    public final Object parseObject(String source,
                                    ParsePosition parsePosition)

  Parses a string to produce an object.
  Overrides:
    `parseObject` in class `Format`
  Parameters:
    `source` - the string to parse.
    `parsePosition` - Input-Output parameter. On input, the position to begin parsing. On output, the position of the first unparse character.
  Returns:
    Object parsed from string. In case of error, returns null.
  See Also:
    `ParsePosition`

### format

    public final String format(double number)

  Specialization of format.
  See Also:
    `Format.format(java.lang.Object)`

### format

    public final String format(long number)

  Specialization of format.
  See Also:
    `Format.format(java.lang.Object)`

### format

    public abstract StringBuffer format(double number,
                                        StringBuffer toAppendTo,
                                        FieldPosition pos)

  Specialization of format.
  See Also:
    `Format.format(java.lang.Object)`

### format

    public abstract StringBuffer format(long number,
                                        StringBuffer toAppendTo,
                                        FieldPosition pos)

  Specialization of format.
  See Also:
    `Format.format(java.lang.Object)`

### parse

    public abstract Number parse(String text,
                                 ParsePosition parsePosition)

  Returns a Long if possible (e.g., within the range [Long.MIN_VALUE, Long.MAX_VALUE] and with no decimals), otherwise a Double. If IntegerOnly is set, will stop at a decimal point (or equivalent; e.g., for rational numbers "1 2/3", will stop after the 1). Does not throw an exception; if no object can be parsed, index is unchanged!
  See Also:
    `isParseIntegerOnly()`, `Format.parseObject(java.lang.String, java.text.ParsePosition)`

### parse

    public Number parse(String text)
                 throws ParseException

  Convenience method.
  Throws:
    `ParseException` - if the specified string is invalid.
  See Also:
    `format(java.lang.Object, java.lang.StringBuffer, java.text.FieldPosition)`

### isParseIntegerOnly

    public boolean isParseIntegerOnly()

  Returns true if this format will parse numbers as integers only. For example in the English locale, with ParseIntegerOnly true, the string "1234." would be parsed as the integer value 1234 and parsing would stop at the "." character. Of course, the exact format accepted by the parse operation is locale dependant and determined by sub-classes of NumberFormat.

### setParseIntegerOnly

    public void setParseIntegerOnly(boolean value)

  Sets whether or not numbers should be parsed as integers only.
  See Also:
    `isParseIntegerOnly()`

### getInstance

    public static final NumberFormat getInstance()

  Returns the default number format for the current default locale. The default format is one of the styles provided by the other factory methods: getNumberInstance, getCurrencyInstance or getPercentInstance. Exactly which one is locale dependant.

### getInstance

    public static NumberFormat getInstance(Locale inLocale)

  Returns the default number format for the specified locale. The default format is one of the styles provided by the other factory methods: getNumberInstance, getCurrencyInstance or getPercentInstance. Exactly which one is locale dependant.

### getNumberInstance

    public static final NumberFormat getNumberInstance()

  Returns a general-purpose number format for the current default locale.

### getNumberInstance

    public static NumberFormat getNumberInstance(Locale inLocale)

  Returns a general-purpose number format for the specified locale.

### getCurrencyInstance

    public static final NumberFormat getCurrencyInstance()

  Returns a currency format for the current default locale.

### getCurrencyInstance

    public static NumberFormat getCurrencyInstance(Locale inLocale)

  Returns a currency format for the specified locale.

### getPercentInstance

    public static final NumberFormat getPercentInstance()

  Returns a percentage format for the current default locale.

### getPercentInstance

    public static NumberFormat getPercentInstance(Locale inLocale)

  Returns a percentage format for the specified locale.

### getAvailableLocales

    public static Locale[] getAvailableLocales()

  Get the set of Locales for which NumberFormats are installed
  Returns:
    available locales

### hashCode

    public int hashCode()

  Overrides hashCode
  Overrides:
    `hashCode` in class `Object`
  Following copied from class: `java.lang.Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### equals

    public boolean equals(Object obj)

  Overrides equals
  Overrides:
    `equals` in class `Object`
  Following copied from class: `java.lang.Object`
  Parameters:
    `obj` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Boolean.hashCode()`, `Hashtable`

### clone

    public Object clone()

  Overrides Cloneable
  Overrides:
    `clone` in class `Format`
  Following copied from class: `java.lang.Object`
  Returns:
    a clone of this instance.
  Throws:
    `CloneNotSupportedException` - if the object's class does not support the `Cloneable` interface. Subclasses that override the `clone` method can also throw this exception to indicate that an instance cannot be cloned.
    `OutOfMemoryError` - if there is not enough memory.
  See Also:
    `Cloneable`

### isGroupingUsed

    public boolean isGroupingUsed()

  Returns true if grouping is used in this format. For example, in the English locale, with grouping on, the number 1234567 might be formatted as "1,234,567". The grouping separator as well as the size of each group is locale dependant and is determined by sub-classes of NumberFormat.
  See Also:
    `setGroupingUsed(boolean)`

### setGroupingUsed

    public void setGroupingUsed(boolean newValue)

  Set whether or not grouping will be used in this format.
  See Also:
    `isGroupingUsed()`

### getMaximumIntegerDigits

    public int getMaximumIntegerDigits()

  Returns the maximum number of digits allowed in the integer portion of a number.
  See Also:
    `setMaximumIntegerDigits(int)`

### setMaximumIntegerDigits

    public void setMaximumIntegerDigits(int newValue)

  Sets the maximum number of digits allowed in the integer portion of a number. maximumIntegerDigits must be >= minimumIntegerDigits. If the new value for maximumIntegerDigits is less than the current value of minimumIntegerDigits, then minimumIntegerDigits will also be set to the new value.
  Parameters:
    `newValue` - the maximum number of integer digits to be shown; if less than zero, then zero is used. The concrete subclass may enforce an upper limit to this value appropriate to the numeric type being formatted.
  See Also:
    `getMaximumIntegerDigits()`

### getMinimumIntegerDigits

    public int getMinimumIntegerDigits()

  Returns the minimum number of digits allowed in the integer portion of a number.
  See Also:
    `setMinimumIntegerDigits(int)`

### setMinimumIntegerDigits

    public void setMinimumIntegerDigits(int newValue)

  Sets the minimum number of digits allowed in the integer portion of a number. minimumIntegerDigits must be <= maximumIntegerDigits. If the new value for minimumIntegerDigits exceeds the current value of maximumIntegerDigits, then maximumIntegerDigits will also be set to the new value
  Parameters:
    `newValue` - the minimum number of integer digits to be shown; if less than zero, then zero is used. The concrete subclass may enforce an upper limit to this value appropriate to the numeric type being formatted.
  See Also:
    `getMinimumIntegerDigits()`

### getMaximumFractionDigits

    public int getMaximumFractionDigits()

  Returns the maximum number of digits allowed in the fraction portion of a number.
  See Also:
    `setMaximumFractionDigits(int)`

### setMaximumFractionDigits

    public void setMaximumFractionDigits(int newValue)

  Sets the maximum number of digits allowed in the fraction portion of a number. maximumFractionDigits must be >= minimumFractionDigits. If the new value for maximumFractionDigits is less than the current value of minimumFractionDigits, then minimumFractionDigits will also be set to the new value.
  Parameters:
    `newValue` - the maximum number of fraction digits to be shown; if less than zero, then zero is used. The concrete subclass may enforce an upper limit to this value appropriate to the numeric type being formatted.
  See Also:
    `getMaximumFractionDigits()`

### getMinimumFractionDigits

    public int getMinimumFractionDigits()

  Returns the minimum number of digits allowed in the fraction portion of a number.
  See Also:
    `setMinimumFractionDigits(int)`

### setMinimumFractionDigits

    public void setMinimumFractionDigits(int newValue)

  Sets the minimum number of digits allowed in the fraction portion of a number. minimumFractionDigits must be <= maximumFractionDigits. If the new value for minimumFractionDigits exceeds the current value of maximumFractionDigits, then maximumIntegerDigits will also be set to the new value
  Parameters:
    `newValue` - the minimum number of fraction digits to be shown; if less than zero, then zero is used. The concrete subclass may enforce an upper limit to this value appropriate to the numeric type being formatted.
  See Also:
    `getMinimumFractionDigits()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >